Index: /trunk/SophyaPI/PI/Makefile
===================================================================
--- /trunk/SophyaPI/PI/Makefile	(revision 56)
+++ /trunk/SophyaPI/PI/Makefile	(revision 57)
@@ -1,7 +1,12 @@
+MODULENAME := PI
 include ../Mgr/Makefile.h
  
 all: $(LIB)libPI.a
-$(LIB)libPI.a : $(OBJ)piapplgen.o $(OBJ)piapplx.o $(OBJ)pibwdggen.o $(OBJ)pibwdgx.o $(OBJ)picmap.o $(OBJ)picmapgen.o $(OBJ)picmapx.o $(OBJ)picontainergen.o $(OBJ)picontainerx.o $(OBJ)pidrawwin.o $(OBJ)pifilechogen.o $(OBJ)pifilechox.o $(OBJ)pihisto.o $(OBJ)piimage.o $(OBJ)pilistgen.o $(OBJ)pilistx.o $(OBJ)pimenubargen.o $(OBJ)pimenubarx.o $(OBJ)pimenugen.o $(OBJ)pimenux.o $(OBJ)pimsghandler.o $(OBJ)pioptmenugen.o $(OBJ)pioptmenux.o $(OBJ)piperiodx.o $(OBJ)pipixmapgen.o $(OBJ)pipixmapx.o $(OBJ)piscdrawwdg.o $(OBJ)pistdwdggen.o $(OBJ)pistdwdgx.o $(OBJ)pistlist.o $(OBJ)piup.o $(OBJ)piwdggen.o $(OBJ)piwdgx.o $(OBJ)piwindowgen.o $(OBJ)piwindowx.o $(OBJ)pixtbase.o $(OBJ)psfile.o
-	$(AR) $(ARFLAGS)  $@ $?
+$(LIB)libPI.a : $(OBJ)piapplgen.o $(OBJ)piapplx.o $(OBJ)pibwdggen.o $(OBJ)pibwdgx.o $(OBJ)picmap.o $(OBJ)picmapgen.o $(OBJ)picmapx.o $(OBJ)picontainergen.o $(OBJ)picontainerx.o $(OBJ)pidrawer.o $(OBJ)pidrawwin.o $(OBJ)pifilechogen.o $(OBJ)pifilechox.o $(OBJ)pihisto.o $(OBJ)piimage.o $(OBJ)pilistgen.o $(OBJ)pilistx.o $(OBJ)pimenubargen.o $(OBJ)pimenubarx.o $(OBJ)pimenugen.o $(OBJ)pimenux.o $(OBJ)pimsghandler.o $(OBJ)pintuple.o $(OBJ)pioptmenugen.o $(OBJ)pioptmenux.o $(OBJ)piperiodx.o $(OBJ)pipixmapgen.o $(OBJ)pipixmapx.o $(OBJ)piscdrawwdg.o $(OBJ)pistdwdggen.o $(OBJ)pistdwdgx.o $(OBJ)pistlist.o $(OBJ)piup.o $(OBJ)piwdggen.o $(OBJ)piwdgx.o $(OBJ)piwindowgen.o $(OBJ)piwindowx.o $(OBJ)pixtbase.o $(OBJ)psfile.o
+	$(AR) $(ARFLAGS)  $@ $? 
+ifeq ($(CXX),cxx)
+	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -L$(LIB) -lPI -lOutils++ -lImages++ -lStarReco++ -o $(OBJ)xx.x -Hf
+	$(AR) $(ARFLAGS)  $@ $(REPM)/*.o 
+endif 
  
 $(OBJ)piapplgen.o: piapplgen.cc piapplgen.h pimsghandler.h pisysdep.h \
@@ -12,9 +17,9 @@
  pimenubargen.h pimenux.h pimenugen.h
 $(OBJ)pibwdggen.o: pibwdggen.cc pibwdggen.h pisysdep.h piwdgx.h piwdggen.h \
- pimsghandler.h psfile.h $(INC)defs.h \
- pibwdgx.h picmap.h picmapx.h picmapgen.h
-$(OBJ)pibwdgx.o: pibwdgx.cc pibwdgx.h pisysdep.h pibwdggen.h piwdgx.h \
- piwdggen.h pimsghandler.h pixtbaseP.h pixtbase.h psfile.h \
- $(INC)defs.h picmap.h picmapx.h picmapgen.h
+ pimsghandler.h picmap.h picmapx.h picmapgen.h pidrawer.h psfile.h \
+ $(INC)defs.h pibwdgx.h
+$(OBJ)pibwdgx.o: pibwdgx.cc pixtbaseP.h pibwdgx.h pisysdep.h pibwdggen.h \
+ piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
+ pixtbase.h pidrawer.h psfile.h $(INC)defs.h
 $(OBJ)picmap.o: picmap.cc picmap.h pisysdep.h picmapx.h picmapgen.h
 $(OBJ)picmapgen.o: picmapgen.cc picmapgen.h pisysdep.h picmapx.h picmap.h
@@ -25,8 +30,11 @@
 $(OBJ)picontainerx.o: picontainerx.cc picontainerx.h pisysdep.h \
  picontainergen.h piwdgx.h piwdggen.h pimsghandler.h
+$(OBJ)pidrawer.o: pidrawer.cc pidrawer.h pibwdggen.h pisysdep.h piwdgx.h \
+ piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h psfile.h \
+ $(INC)defs.h pibwdgx.h
 $(OBJ)pidrawwin.o: pidrawwin.cc pidrawwin.h pisysdep.h piwindowx.h \
  piwindowgen.h picontainerx.h picontainergen.h piwdgx.h piwdggen.h \
- pimsghandler.h piscdrawwdg.h pibwdgx.h pibwdggen.h pistdwdgx.h \
- pistdwdggen.h
+ pimsghandler.h piscdrawwdg.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
+ picmapgen.h pistdwdgx.h pistdwdggen.h pidrawer.h
 $(OBJ)pifilechogen.o: pifilechogen.cc pifilechogen.h pisysdep.h piwdgx.h \
  piwdggen.h pimsghandler.h
@@ -34,16 +42,20 @@
  piwdgx.h piwdggen.h pimsghandler.h piwindowx.h piwindowgen.h \
  picontainerx.h picontainergen.h
-$(OBJ)pihisto.o: pihisto.cc pihisto.h piscdrawwdg.h pisysdep.h pibwdgx.h \
- pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h pistdwdgx.h \
- pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
- picontainergen.h $(INC)histos.h \
- $(INC)peida.h \
- $(INC)defs.h \
- $(INC)utils.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)fmath.h
+$(OBJ)pihisto.o: pihisto.cc pihisto.h $(INC)histos.h \
+ $(INC)peida.h \
+ $(INC)defs.h \
+ $(INC)utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)fmath.h \
+ $(INC)cvector.h \
+ $(INC)matrix.h \
+ $(INC)ppersist.h \
+ $(INC)pclassids.h piscdrawwdg.h pisysdep.h \
+ pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
+ picmapx.h picmapgen.h pistdwdgx.h pistdwdggen.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h pidrawer.h
 $(OBJ)piimage.o: piimage.cc piimage.h $(INC)cimage.h \
  $(INC)rzimage.h \
@@ -96,4 +108,16 @@
  piwdggen.h pimsghandler.h
 $(OBJ)pimsghandler.o: pimsghandler.cc pimsghandler.h
+$(OBJ)pintuple.o: pintuple.cc pintuple.h \
+ $(INC)ntuple.h \
+ $(INC)ppersist.h \
+ $(INC)defs.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)pclassids.h piscdrawwdg.h pisysdep.h \
+ pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
+ picmapx.h picmapgen.h pistdwdgx.h pistdwdggen.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h pidrawer.h
 $(OBJ)pioptmenugen.o: pioptmenugen.cc pioptmenugen.h pisysdep.h \
  picontainerx.h picontainergen.h piwdgx.h piwdggen.h pimsghandler.h \
@@ -111,8 +135,6 @@
  pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
  picmapx.h picmapgen.h psfile.h $(INC)defs.h
-$(OBJ)piscdrawwdg.o: piscdrawwdg.cc piscdrawwdg.h pisysdep.h pibwdgx.h \
- pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h pistdwdgx.h \
- pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
- picontainergen.h $(INC)generalfit.h \
+$(OBJ)piscdrawwdg.o: piscdrawwdg.cc \
+ $(INC)generalfit.h \
  $(INC)exceptions.h \
  $(INC)defs.h \
@@ -126,13 +148,14 @@
  $(INC)ppersist.h \
  $(INC)pclassids.h \
- $(INC)cvector.h
+ $(INC)cvector.h piscdrawwdg.h pisysdep.h \
+ pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
+ picmapx.h picmapgen.h pistdwdgx.h pistdwdggen.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h pidrawer.h
 $(OBJ)pistdwdggen.o: pistdwdggen.cc pistdwdggen.h pisysdep.h piwdgx.h \
  piwdggen.h pimsghandler.h
 $(OBJ)pistdwdgx.o: pistdwdgx.cc pisysdep.h pistdwdgx.h pistdwdggen.h \
  piwdgx.h piwdggen.h pimsghandler.h
-$(OBJ)pistlist.o: pistlist.cc pistlist.h piscdrawwdg.h pisysdep.h pibwdgx.h \
- pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h pistdwdgx.h \
- pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
- picontainergen.h $(INC)stlist.h \
+$(OBJ)pistlist.o: pistlist.cc pistlist.h \
+ $(INC)stlist.h \
  $(INC)machine.h \
  $(INC)defs.h \
@@ -156,10 +179,15 @@
  $(INC)datatypes.h \
  $(INC)dvlist.h \
+ $(INC)fct1dfit.h \
  $(INC)generalfit.h \
  $(INC)matrix.h \
  $(INC)cvector.h \
+ $(INC)fct2dfit.h \
  $(INC)transfo.h \
  $(INC)poly.h \
- $(INC)zfidu.h
+ $(INC)zfidu.h piscdrawwdg.h pisysdep.h \
+ pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
+ picmapx.h picmapgen.h pistdwdgx.h pistdwdggen.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h pidrawer.h
 $(OBJ)piup.o: piup.cc $(INC)ctimer.h \
  $(INC)peida.h \
@@ -206,5 +234,6 @@
  picontainerx.h picontainergen.h piwdgx.h piwdggen.h pimsghandler.h
 $(OBJ)pixtbase.o: pixtbase.cc pixtbaseP.h pibwdgx.h pisysdep.h pibwdggen.h \
- piwdgx.h piwdggen.h pimsghandler.h pixtbase.h
+ piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
+ pixtbase.h
 $(OBJ)psfile.o: psfile.cc psfile.h $(INC)defs.h \
  pisysdep.h pibwdgx.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h \